; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 640
WINDOWHEIGHT = 500
yrot	equ xrot+4
zrot	equ xrot+8
yspeed	equ xspeed+4
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	charx:dword
local	chary:dword
local	red:dword
local	green:dword
local	blue:dword
local	x:dword
local	y:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,BMPTexture
	invoke	GlobalFree
	mov	ecx,BMPTexture+4
	invoke	GlobalFree
        mov	ecx,_Font_List
	invoke	glDeleteLists,,256
	invoke	RtlExitUserProcess,NULL
wmTIMER:;movaps	xmm0,xrot
;	addps	xmm0,xspeed;0.14, 0.14, 0.14
;	movaps	xrot,xmm0

	movaps	xmm0,cnt1	; Increase cnt1 & cnt2
	addps	xmm0,delta
	movaps	cnt1,xmm0	
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,2

	mov	ecx,offset txt_Font_BMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax	
	mov	BMPTexture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]

	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;      
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id[0*8]
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
;---------------------------------------------------------------------------------
	mov	ecx,offset txt_Bumps_BMP
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax	
	mov	BMPTexture+4,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]

	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax

	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id[1*8]
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
;----------------------------------------------------------
	invoke	glGenLists, 256		; Create 256 display lists
	mov	_Font_List,eax	
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id[0*8]; Select the font texture
	
	xor	esi,esi
@1:	mov	eax,esi	; charx = (temp2 mod 16)/16		chary = 1 - int(temp2/16)/16 
	mov	edx,eax
	and	edx,0Fh
	shr	eax,4		
	cvtsi2ss xmm0,eax
	divss	xmm0,const16
	movd	xmm1,const1
	subss	xmm1,xmm0
	movd	chary,xmm1
		
	cvtsi2ss xmm0,edx
	divss	xmm0,const16
	movd	charx,xmm0
		
	mov	ecx,esi
	add	ecx,_Font_List
	invoke	glNewList,,GL_COMPILE		; Start building a list
	invoke	glBegin,GL_QUADS	; Use a quad for each character
				
	movd	xmm1,chary	; Texture coord, bottom left
	subss	xmm1,const0_0625
	movd	chary,xmm1
	movd	xmm0,charx
	invoke	glTexCoord2f;, charx, chary
	invoke	glVertex2i, 0, 0
				
	movd	xmm0,charx	; Texture coord, bottom right
	addss	xmm0,const0_0625
	movd	charx,xmm0
	movd	xmm1,chary
	invoke	glTexCoord2f;, charx, chary
	invoke	glVertex2i, 16, 0
				
	movd	xmm1,chary	; Texture coord, top right
	addss	xmm1,const0_0625
	movd	chary,xmm1
	movd	xmm0,charx
	invoke	glTexCoord2f;, charx, chary
	invoke	glVertex2i,16,16
				
	movd	xmm0,charx	; Texture coord, top left
	subss	xmm0,const0_0625
	movd	charx,xmm0
	movd	xmm1,chary
	invoke	glTexCoord2f;, charx, chary
	invoke	glVertex2i, 0, 16
			
	invoke	glEnd	; Done building the quad
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,const10		
	invoke	glTranslatef		
	invoke	glEndList	; Done building the display list		
	inc	esi
	cmp	esi,256
	jb	@1
;----------------------------------------------------------
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
        invoke	glDepthFunc,GL_LEQUAL ;  
        invoke	glBlendFunc, GL_SRC_ALPHA, GL_ONE
	invoke	glShadeModel,GL_SMOOTH;smooth shading
        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
;-------------------------------------------------------------------
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()
	invoke	SetTimer,hWin,10,12,0;  #10  25mSec
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
        invoke	glBindTexture, GL_TEXTURE_2D,Texture1_Id[1*8]
	movd	xmm6,const1
	xorps	xmm7,xmm7
	subss	xmm7,xmm6
;     (z=-6)
	movd	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef

	movss	xmm3,xmm6
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const45
	invoke	glRotatef
	movd	xmm0,const30
	mulss	xmm0,cnt1
	movss	red,xmm0

	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	movss	xmm1,xmm6
	invoke	glRotatef

        invoke	glDisable, GL_BLEND			; Disable blending

	movss	xmm2,xmm6
	movss	xmm1,xmm6
	movss	xmm0,xmm6
        invoke	glColor3f; 1, 1, 1											; Bright white
	invoke	glBegin,GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTexCoord2f; 0, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm7
        invoke	glVertex2f; -1, 1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
        invoke	glTexCoord2f; 1, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm6
        invoke	glVertex2f; 1, 1
	movss	xmm1,xmm6
	movss	xmm0,xmm6
        invoke	glTexCoord2f; 1, 1
	movss	xmm1,xmm7
	movss	xmm0,xmm6
        invoke	glVertex2f; 1, -1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
        invoke	glTexCoord2f; 0, 1
	movss	xmm1,xmm7
	movss	xmm0,xmm7
        invoke	glVertex2f; -1, -1
	invoke	glEnd
	
	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	movss	xmm1,xmm6
	movss	xmm0,const90
        invoke	glRotatef; 90, 1, 1, 0
	invoke	glBegin, GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTexCoord2f; 0, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm7
        invoke	glVertex2f; -1, 1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
        invoke	glTexCoord2f; 1, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm6
        invoke	glVertex2f; 1, 1
	movss	xmm1,xmm6
	movss	xmm0,xmm6
        invoke	glTexCoord2f; 1, 1
	movss	xmm1,xmm7
	movss	xmm0,xmm6
        invoke	glVertex2f; 1, -1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
        invoke	glTexCoord2f; 0, 1
	movss	xmm1,xmm7
	movss	xmm0,xmm7
        invoke	glVertex2f; -1, -1
	invoke	glEnd
	
	invoke	glEnable, GL_BLEND
	invoke	glLoadIdentity
	
	movd	xmm0,cnt1
	invoke	cosf
	movd	red,xmm0
	movd	xmm0,cnt1+4
	invoke	sinf
	movd	green,xmm0
	movd	xmm0,cnt1
	addss	xmm0,cnt1+4
	invoke	cosf
	mulss	xmm0,const0_5
	movd	xmm2,const1
	subss	xmm2,xmm0
	movd	blue,xmm2
	movd	xmm1,green
	movd	xmm0,red
	invoke	glColor3f; red, green, blue
	
	movd	xmm0,cnt1
	invoke	cosf
	mulss	xmm0,const250
	addss	xmm0,const280
	movd	x,xmm0
	movd	xmm0,cnt1+4
	invoke	sinf
	mulss	xmm0,const200
	addss	xmm0,const235
	movd	y,xmm0
	movss	xmm1,xmm0
	mov	r8d,offset txt_NeHe
	movd	xmm0,x
	invoke	glPrint,,,,0		; Print NeHe on the screen
	
	movd	xmm0,cnt1+4
	invoke	sinf
	movd	red,xmm0	; Calc red for OpenGL

	movd	xmm0,cnt1
	addss	xmm0,cnt1+4
	invoke	cosf
	mulss	xmm0,const_0_5
	movd	xmm1,const1
	subss	xmm1,xmm0
	movd	green,xmm1	; Calc green for OpenGL
	
	movd	xmm0,cnt1
	invoke	cosf
	movd	blue,xmm0	; Calc blue for OpenGl
	movss	xmm2,xmm0
	movd	xmm1,green
	movd	xmm0,red
	invoke	glColor3f;, red, green, blue

	movd	xmm0,cnt1+4
	invoke	cosf
	mulss	xmm0,const230
	addss	xmm0,const280
	movd	x,xmm0		; X Coord for OpenGL
	movd	xmm0,cnt1
	invoke	sinf
	mulss	xmm0,const200
	addss	xmm0,const235
	movd	y,xmm0		; Y Coord for OpenGL
	movss	xmm1,xmm0
	mov	r8d,offset txt_OpenGL 
	movd	xmm0,x
	invoke glPrint,,,,1	; Print OpenGL on the screen
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glColor3f;0, 0, 1	Set blue colour
	movd	xmm0,cnt1
	addss	xmm0,cnt1+4
	divss	xmm0,const2
	invoke	cosf
	mulss	xmm0,const200
	addss	xmm0,const240
	movd	x,xmm0
	movd	xmm1,const2;y
	mov	r8d,offset txt_Giueseppe
	
	invoke	glPrint,,,,0
	movss	xmm2,xmm6
	movss	xmm1,xmm6
	movss	xmm0,xmm6
	invoke	glColor3f;1,1,1	Set white colour
	movd	xmm1,const2;y
	movd	xmm0,x
	addss	xmm0,xmm1;x+2
	mov	r8d,offset txt_Giueseppe 
	invoke	glPrint,,,,0
	
        invoke  glFlush                          
;                           
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
glPrint proc x:dword, y:dword, string:DWORD, set:dword

	mov	string,r8d
	mov	set,r9d	
	movd	x,xmm0
	movd	y,xmm1
	
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id	; Select the font texture	
	invoke	glDisable, GL_DEPTH_TEST		; Disable depth testing
	invoke	glMatrixMode, GL_PROJECTION	; Select projection matrix
	invoke	glPushMatrix										; Store the projection matrix
	invoke	glLoadIdentity			; Reset projection matrix
        movq	xmm3,constd480
	xorps	xmm2,xmm2
	movq	xmm1,constd640
	xorps	xmm0,xmm0
	invoke	glOrtho,,,,,constd_1,constd1		; Set up an Ortho screen
	invoke	glMatrixMode,GL_MODELVIEW	; Select modelview matrix
	invoke	glPushMatrix			; Store the modelview matrix
	invoke	glLoadIdentity			; Reset the modelview matrix
	xorps	xmm2,xmm2
	movd	xmm1,y
	movd	xmm0,x
	invoke	glTranslatef
	mov	ecx,set	
	shl	ecx,7;set*128											; Choose the font set
	add	ecx,_Font_List
	sub	ecx,32
	invoke	glListBase
	mov	ecx,string		
	invoke	lstrlen
	mov	r8d,string
	invoke	glCallLists,eax,GL_BYTE				; Write the text to the screen
	
	invoke	glMatrixMode,GL_PROJECTION						; Select projection matrix
	invoke	glPopMatrix										; Restore the old matrix
	invoke	glMatrixMode,GL_MODELVIEW						; Select modelview matrix
	invoke	glPopMatrix										; Restore the old matrix
	invoke	glEnable,GL_DEPTH_TEST							; Enable depth testing
	leave
	ret
glPrint endp
;----------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #17: 2D-Texture Font",0
FileName	db "br_Rabbit3.cur",0
BMPTexture	dd ?,?
Texture1_Id	dq ?,?   
z		dd -5.0
txt_NeHe	db "NeHe",0
txt_Giueseppe	db "Giuseppe D'Agata",0
txt_OpenGL	db "OpenGL",0
txt_Font_BMP	db "Font.BMP",0
txt_Bumps_BMP	db "Bumps.BMP",0
_Font_List	dd ?	; Base display list for the font
;-----------------------------
;float
const0_0625	dd 0.0625
const0_5	dd 0.5
const_0_5	dd -0.5
const1		dd 1.0
const2		dd 2.0
const10		dd 10.0
const16		dd 16.0
const30		dd 30.0
const45		dd 45.0
const90		dd 90.0
const200	dd 200.0
const230	dd 230.0
const235	dd 235.0
const240	dd 240.0
const250	dd 250.0
const280	dd 280.0
;double
constd0_1	dq 0.1
constd1		dq 1.0
constd_1	dq -1.0
constd45	dq 45.0
constd100	dq 100.0
constd480	dq 480.0
constd640	dq 640.0
align 16
;xrot		dd 0,  0,  0,  0
;xspeed		dd 1.4, 1.4, 1.4, 0
cnt1		dd ?,?,0,0; 1st temp used to move text & for colouring you guessed it.. second temp
delta		dd 0.01, 0.0081, 0, 0
end